//
// Cheap DSP dsPIC30 radio board LTC1659 12-bit DAC driver
// Juha Niinikoski, OH2NLT 15.11.2005
//
// Hi-Tech dsPICC_9.50 compiler, MPLAB 7.00
// 

//#define	LTC1659_DIN	LATBx			// LTC1659 Data In
//#define	LTC1659_CLK	LATBx			// LTC1659 Clock
//#define	LTC1659_CS	LATBx			// LTC1659 Data CS

void ltc1659_dly(void)			// delay for LTC1659 signals
	{
	asm(" nop");
	asm(" nop");
	asm(" nop");
	asm(" nop");
	}

void set_ltc1659(int out_val)
	{
	int x;
	LTC1659_CS = 0;				// start cycle
	for(x=0; x<12; x++)
		{
		if(out_val & 0x0800)	// start from bit #11
			LTC1659_DIN = 1;	// evaluate bit
		else
			LTC1659_DIN = 0;
	
		out_val = out_val << 1;	// addjust data for next round

		ltc1659_dly();
		LTC1659_CLK = 1;		// generate clock
		ltc1659_dly();
		LTC1659_CLK = 0;		
		}
	LTC1659_CS = 1;				// end cycle	
	}

// init DAC signals

void init_ltc1659(void)
	{
	LTC1659_CS = 1;				// set signals to idle
	set_ltc1659(0);				// set DAC to zero
	}
